/* Generated By:JavaCC: Do not edit this line. SgfParser.java */
package de.uni_due.inf.ti.graph.io;

import java.io.IOException;
import java.io.Reader;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import de.uni_due.inf.ti.graph.Graph;
import de.uni_due.inf.ti.graph.io.SgfTerm.GraphDefTerm;
import de.uni_due.inf.ti.graph.io.SgfTerm.IfGraphDefTerm;
import de.uni_due.inf.ti.graph.io.SgfTerm.MapstoTerm;
import de.uni_due.inf.ti.graph.io.SgfTerm.RefTerm;

@SuppressWarnings("all")
public class SgfParser implements SgfParserConstants {
    /**
     * Parses a graph definition from an input stream.
     *
     * @param in
     *      reader from which the graph definition is read
     * @returns
     *      graph which is parsed from in
     * @throws NullPointerException
     *      when in is null
     * @throws IOException
     *      when a parse or IO error occurs
     */
    public static Graph parseGraph(Reader in) throws IOException
    {
        if (in == null) throw new NullPointerException();

        SgfParser parser = new SgfParser(in);
        try {
            SgfTerm term = parser.graphFile();
            return SgfBuilder.termToGraph(term);
        }
        catch (ParseException e) {
            throw new IOException("Not an SGF graph file.", e);
        }
        catch (SgfBuildException e) {
            throw new IOException("Not an SGF graph file.", e);
        }
    }

    /**
     * Parses a collection of named objects from an input stream. The named
     * objects are returned as a map which maps a name to the object with
     * that name.
     *
     * @param in
     *      reader from which the graph definition is read
     * @returns
     *      objects which are parsed from the input
     * @throws NullPointerException
     *      when in is null
     * @throws IOException
     *      when a parse or IO error occurs
     */
    public static Map<String,Object> parseSgfFile(Reader in) throws IOException
    {
        if (in == null) throw new NullPointerException();

        SgfParser parser = new SgfParser(in);
        try {
            List<SgfTerm> defs = parser.sgfFile();
            return SgfBuilder.termsToObjects(defs);
        }
        catch (ParseException e) {
            throw new IOException("Not a correct SGF file.", e);
        }
        catch (SgfBuildException e) {
            throw new IOException("Not a correct SGF graph file.", e);
        }
    }

  final private RefTerm noKwident() throws ParseException {
    Token t;
    String ident;
    t = jj_consume_token(IDENT);
      {if (true) return SgfTerm.createRefTerm(t.beginLine, t.beginColumn, t.image);}
    throw new Error("Missing return statement in function");
  }

  final private RefTerm ident() throws ParseException {
    Token t;
    String ident;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENT:
      t = jj_consume_token(IDENT);
          ident = t.image;
      break;
    case STRING:
      t = jj_consume_token(STRING);
          ident = t.image.substring(1, t.image.length() - 1);
      break;
    case KW_INITIAL:
      t = jj_consume_token(KW_INITIAL);
          ident = "initial";
      break;
    case KW_LEFT:
      t = jj_consume_token(KW_LEFT);
          ident = "left";
      break;
    case KW_NACS:
      t = jj_consume_token(KW_NACS);
          ident = "nacs";
      break;
    case KW_RIGHT:
      t = jj_consume_token(KW_RIGHT);
          ident = "right";
      break;
    case KW_RULES:
      t = jj_consume_token(KW_RULES);
          ident = "rules";
      break;
    case KW_TRANS:
      t = jj_consume_token(KW_TRANS);
          ident = "transitions";
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return SgfTerm.createRefTerm(t.beginLine, t.beginColumn, ident);}
    throw new Error("Missing return statement in function");
  }

  final private List<RefTerm> identList() throws ParseException {
    List<RefTerm> result = new ArrayList<RefTerm>();
    RefTerm ident;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OP_BRACKET_OPEN:
      jj_consume_token(OP_BRACKET_OPEN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
      case KW_LEFT:
      case KW_NACS:
      case KW_RIGHT:
      case KW_RULES:
      case KW_TRANS:
      case IDENT:
      case STRING:
        ident = ident();
                          result.add(ident);
        label_1:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_COMMA:
            ;
            break;
          default:
            jj_la1[1] = jj_gen;
            break label_1;
          }
          jj_consume_token(OP_COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case KW_INITIAL:
          case KW_LEFT:
          case KW_NACS:
          case KW_RIGHT:
          case KW_RULES:
          case KW_TRANS:
          case IDENT:
          case STRING:
            ident = ident();
                                         result.add(ident);
            break;
          default:
            jj_la1[2] = jj_gen;
            ;
          }
        }
        break;
      default:
        jj_la1[3] = jj_gen;
        ;
      }
      jj_consume_token(OP_BRACKET_CLOSE);
      {if (true) return result;}
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      ident = ident();
      result.add(ident);
      {if (true) return result;}
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private String nodeRef() throws ParseException {
    RefTerm name;
    name = ident();
      {if (true) return name.getName();}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm nodeDef() throws ParseException {
    RefTerm name = null;
    Token t;
    t = jj_consume_token(KW_NODE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      name = ident();
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
      {if (true) return SgfTerm.createNodeDefTerm(t.beginLine, t.beginColumn,
          name == null ? null : name.getName());}
    throw new Error("Missing return statement in function");
  }

  final private List<SgfTerm> edgesDef() throws ParseException {
    Token t;
    RefTerm prelab;
    RefTerm postlab = null;
    RefTerm node1, node2;
    List<SgfTerm> result = new ArrayList<SgfTerm>();
    List<String> nodes;
    if (jj_2_1(2)) {
      // binary edge
              node1 = ident();
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OP_BINEDGE_START:
          t = jj_consume_token(OP_BINEDGE_START);
          prelab = ident();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_COLON:
            jj_consume_token(OP_COLON);
            postlab = ident();
            break;
          default:
            jj_la1[6] = jj_gen;
            ;
          }
          jj_consume_token(OP_BINEDGE_RIGHT);
          node2 = ident();
                nodes = new ArrayList<String>();
                nodes.add(node1.getName());
                nodes.add(node2.getName());
                if (postlab == null) {
                    result.add(SgfTerm.createEdgeDefTerm(t.beginLine, t.beginColumn,
                        null, prelab.getName(), nodes));
                }
                else {
                    result.add(SgfTerm.createEdgeDefTerm(t.beginLine, t.beginColumn,
                        prelab.getName(), postlab.getName(), nodes));
                }
                node1 = node2;
          break;
        case OP_BINEDGE_LEFT:
          t = jj_consume_token(OP_BINEDGE_LEFT);
          prelab = ident();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_COLON:
            jj_consume_token(OP_COLON);
            postlab = ident();
            break;
          default:
            jj_la1[7] = jj_gen;
            ;
          }
          jj_consume_token(OP_BINEDGE_START);
          node2 = ident();
                nodes = new ArrayList<String>();
                nodes.add(node2.getName());
                nodes.add(node1.getName());
                if (postlab == null) {
                    result.add(SgfTerm.createEdgeDefTerm(t.beginLine, t.beginColumn,
                        null, prelab.getName(), nodes));
                }
                else {
                    result.add(SgfTerm.createEdgeDefTerm(t.beginLine, t.beginColumn,
                        prelab.getName(), postlab.getName(), nodes));
                }
                node1 = node2;
          break;
        default:
          jj_la1[8] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OP_BINEDGE_START:
        case OP_BINEDGE_LEFT:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_2;
        }
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
      case KW_LEFT:
      case KW_NACS:
      case KW_RIGHT:
      case KW_RULES:
      case KW_TRANS:
      case IDENT:
      case STRING:
        // hyperedge
                prelab = ident();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OP_COLON:
          jj_consume_token(OP_COLON);
          postlab = ident();
          break;
        default:
          jj_la1[10] = jj_gen;
          ;
        }
        jj_consume_token(OP_PAR_OPEN);
                        nodes = new ArrayList<String>();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KW_INITIAL:
        case KW_LEFT:
        case KW_NACS:
        case KW_RIGHT:
        case KW_RULES:
        case KW_TRANS:
        case IDENT:
        case STRING:
          node1 = ident();
              nodes.add(node1.getName());
          label_3:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case OP_COMMA:
              ;
              break;
            default:
              jj_la1[11] = jj_gen;
              break label_3;
            }
            jj_consume_token(OP_COMMA);
            node1 = ident();
                  nodes.add(node1.getName());
          }
          break;
        default:
          jj_la1[12] = jj_gen;
          ;
        }
        jj_consume_token(OP_PAR_CLOSE);
            if (postlab == null) {
                result.add(SgfTerm.createEdgeDefTerm(prelab.getLine(), prelab.getColumn(),
                    null, prelab.getName(), nodes));
            }
            else {
                result.add(SgfTerm.createEdgeDefTerm(prelab.getLine(), prelab.getColumn(),
                    prelab.getName(), postlab.getName(), nodes));
            }
        break;
      default:
        jj_la1[13] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private void graphDefElement(List<SgfTerm> elems) throws ParseException {
    SgfTerm elem;
    List<SgfTerm> edges;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_NODE:
      elem = nodeDef();
        elems.add(elem);
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      edges = edgesDef();
        elems.addAll(edges);
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private GraphDefTerm graphDefBlock(Token t) throws ParseException {
    Token q = null;
    List<SgfTerm> elems = new ArrayList<SgfTerm>();
    q = jj_consume_token(OP_BRACE_OPEN);
      if (t == null) t = q;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_NODE:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      graphDefElement(elems);
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OP_SEMICOLON:
          ;
          break;
        default:
          jj_la1[15] = jj_gen;
          break label_4;
        }
        jj_consume_token(OP_SEMICOLON);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KW_INITIAL:
        case KW_LEFT:
        case KW_NACS:
        case KW_NODE:
        case KW_RIGHT:
        case KW_RULES:
        case KW_TRANS:
        case IDENT:
        case STRING:
          graphDefElement(elems);
          break;
        default:
          jj_la1[16] = jj_gen;
          ;
        }
      }
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return SgfTerm.createGraphDefTerm(t.beginLine, t.beginColumn, elems);}
    throw new Error("Missing return statement in function");
  }

  final private GraphDefTerm graphDef() throws ParseException {
    Token t;
    GraphDefTerm result;
    t = jj_consume_token(KW_GRAPH);
    result = graphDefBlock(t);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm graph() throws ParseException {
    SgfTerm result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_GRAPH:
      result = graphDef();
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      result = ident();
      break;
    default:
      jj_la1[18] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private IfGraphDefTerm ifGraphDef() throws ParseException {
    Token t;
    List<RefTerm> left;
    List<RefTerm> right;
    GraphDefTerm gdt;
    t = jj_consume_token(KW_IFGRAPH);
    jj_consume_token(OP_BRACE_OPEN);
    jj_consume_token(OP_BRACKET_OPEN);
    left = identList();
    jj_consume_token(OP_BRACKET_CLOSE);
    jj_consume_token(OP_MAPSTO);
    gdt = graphDefBlock(null);
    jj_consume_token(OP_MAPSFROM);
    jj_consume_token(OP_BRACKET_OPEN);
    right = identList();
    jj_consume_token(OP_BRACKET_CLOSE);
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return SgfTerm.createIfGraphDefTerm(
          t.beginLine, t.beginColumn,
          gdt.getElements(),
          left, right);}
    throw new Error("Missing return statement in function");
  }

  final private MapstoTerm mapsto() throws ParseException {
    RefTerm from;
    RefTerm to;
    from = ident();
    jj_consume_token(OP_MAPSTO);
    to = ident();
      {if (true) return SgfTerm.createMapstoTerm(from.getLine(), from.getColumn(),
          from.getName(), to.getName());}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm morphismDef() throws ParseException {
    Token t;
    RefTerm fromGraph = null;
    RefTerm toGraph = null;
    MapstoTerm map;
    List<MapstoTerm> pairs = new ArrayList<MapstoTerm>();
    t = jj_consume_token(KW_MORPHISM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_FROM:
      jj_consume_token(KW_FROM);
      fromGraph = ident();
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_TO:
      jj_consume_token(KW_TO);
      toGraph = ident();
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    jj_consume_token(OP_BRACE_OPEN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      map = mapsto();
                         pairs.add(map);
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OP_SEMICOLON:
          ;
          break;
        default:
          jj_la1[21] = jj_gen;
          break label_5;
        }
        jj_consume_token(OP_SEMICOLON);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KW_INITIAL:
        case KW_LEFT:
        case KW_NACS:
        case KW_RIGHT:
        case KW_RULES:
        case KW_TRANS:
        case IDENT:
        case STRING:
          map = mapsto();
                                            pairs.add(map);
          break;
        default:
          jj_la1[22] = jj_gen;
          ;
        }
      }
      break;
    default:
      jj_la1[23] = jj_gen;
      ;
    }
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return SgfTerm.createMorphismDefTerm(t.beginLine, t.beginColumn,
          fromGraph, toGraph, pairs);}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm morphism() throws ParseException {
    SgfTerm result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_MORPHISM:
      result = morphismDef();
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      result = ident();
      break;
    default:
      jj_la1[24] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private List<SgfTerm> morphismList() throws ParseException {
    List<SgfTerm> result = new ArrayList<SgfTerm>();
    SgfTerm morph;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OP_BRACKET_OPEN:
      jj_consume_token(OP_BRACKET_OPEN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
      case KW_LEFT:
      case KW_MORPHISM:
      case KW_NACS:
      case KW_RIGHT:
      case KW_RULES:
      case KW_TRANS:
      case IDENT:
      case STRING:
        morph = morphism();
                             result.add(morph);
        label_6:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_COMMA:
            ;
            break;
          default:
            jj_la1[25] = jj_gen;
            break label_6;
          }
          jj_consume_token(OP_COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case KW_INITIAL:
          case KW_LEFT:
          case KW_MORPHISM:
          case KW_NACS:
          case KW_RIGHT:
          case KW_RULES:
          case KW_TRANS:
          case IDENT:
          case STRING:
            morph = morphism();
                                            result.add(morph);
            break;
          default:
            jj_la1[26] = jj_gen;
            ;
          }
        }
        break;
      default:
        jj_la1[27] = jj_gen;
        ;
      }
      jj_consume_token(OP_BRACKET_CLOSE);
      {if (true) return result;}
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_MORPHISM:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      morph = morphism();
      result.add(morph);
      {if (true) return result;}
      break;
    default:
      jj_la1[28] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm traceItem() throws ParseException {
    SgfTerm item;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_MORPHISM:
      item = morphismDef();
      break;
    case KW_GRAPH:
      item = graphDef();
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      item = ident();
      break;
    default:
      jj_la1[29] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return item;}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm traceDef() throws ParseException {
    Token t;
    List<SgfTerm> items = new ArrayList<SgfTerm>();
    SgfTerm item;
    t = jj_consume_token(KW_TRACE);
    jj_consume_token(OP_BRACE_OPEN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_GRAPH:
    case KW_INITIAL:
    case KW_LEFT:
    case KW_MORPHISM:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      item = traceItem();
                             items.add(item);
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OP_COMMA:
          ;
          break;
        default:
          jj_la1[30] = jj_gen;
          break label_7;
        }
        jj_consume_token(OP_COMMA);
        item = traceItem();
                               items.add(item);
      }
      break;
    default:
      jj_la1[31] = jj_gen;
      ;
    }
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return SgfTerm.createTraceDefTerm(t.beginLine, t.beginColumn, items);}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm trace() throws ParseException {
    SgfTerm trace;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_TRACE:
      trace = traceDef();
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      trace = ident();
      break;
    default:
      jj_la1[32] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return trace;}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm ruleDef() throws ParseException {
    Token t;
    boolean leftSeen = false;
    boolean rightSeen = false;
    boolean morphismSeen = false;
    boolean nacsSeen = false;
    SgfTerm result;
    SgfTerm left = null;
    SgfTerm right = null;
    SgfTerm morph = null;
    SgfTerm nac = null;
    List<SgfTerm> nacs = null;
    t = jj_consume_token(KW_RULE);
    jj_consume_token(OP_BRACE_OPEN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_LEFT:
    case KW_MORPHISM:
    case KW_NACS:
    case KW_RIGHT:
      label_8:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KW_LEFT:
          jj_consume_token(KW_LEFT);
          jj_consume_token(OP_IS);
          left = graph();
          label_9:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case OP_SEMICOLON:
              ;
              break;
            default:
              jj_la1[33] = jj_gen;
              break label_9;
            }
            jj_consume_token(OP_SEMICOLON);
          }
            if (leftSeen) {if (true) throw new ParseException("Duplicate left-hand side.");}
            leftSeen = true;
          break;
        case KW_RIGHT:
          jj_consume_token(KW_RIGHT);
          jj_consume_token(OP_IS);
          right = graph();
          label_10:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case OP_SEMICOLON:
              ;
              break;
            default:
              jj_la1[34] = jj_gen;
              break label_10;
            }
            jj_consume_token(OP_SEMICOLON);
          }
            if (rightSeen) {if (true) throw new ParseException("Duplicate right-hand side.");}
            rightSeen = true;
          break;
        case KW_MORPHISM:
          jj_consume_token(KW_MORPHISM);
          jj_consume_token(OP_IS);
          morph = morphism();
          label_11:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case OP_SEMICOLON:
              ;
              break;
            default:
              jj_la1[35] = jj_gen;
              break label_11;
            }
            jj_consume_token(OP_SEMICOLON);
          }
            if (morphismSeen) {if (true) throw new ParseException("Duplicate rule morphism.");}
            morphismSeen = true;
          break;
        case KW_NACS:
          jj_consume_token(KW_NACS);
          jj_consume_token(OP_IS);
          nacs = morphismList();
          label_12:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case OP_SEMICOLON:
              ;
              break;
            default:
              jj_la1[36] = jj_gen;
              break label_12;
            }
            jj_consume_token(OP_SEMICOLON);
          }
            if (nacsSeen) {if (true) throw new ParseException("Duplicate nacs list.");}
            nacsSeen = true;
          break;
        default:
          jj_la1[37] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KW_LEFT:
        case KW_MORPHISM:
        case KW_NACS:
        case KW_RIGHT:
          ;
          break;
        default:
          jj_la1[38] = jj_gen;
          break label_8;
        }
      }
          result = SgfTerm.createRuleDefTerm(t.beginLine, t.beginColumn, left, right, morph, nacs);
      break;
    case OP_BRACE_OPEN:
      left = graphDefBlock(null);
      jj_consume_token(OP_MAPSTO);
      right = graphDefBlock(null);
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KW_NOT:
          ;
          break;
        default:
          jj_la1[39] = jj_gen;
          break label_13;
        }
        jj_consume_token(KW_NOT);
        nac = graphDefBlock(null);
            if (nacs == null) nacs = new ArrayList<SgfTerm>();
            nacs.add(nac);
      }
          result = SgfTerm.createQuickRuleDefTerm(t.beginLine, t.beginColumn, left, right, nacs);
      break;
    default:
      jj_la1[40] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm rule() throws ParseException {
    SgfTerm rule;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_RULE:
      rule = ruleDef();
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      rule = ident();
      break;
    default:
      jj_la1[41] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return rule;}
    throw new Error("Missing return statement in function");
  }

  final private List<SgfTerm> ruleList() throws ParseException {
    List<SgfTerm> result = new ArrayList<SgfTerm>();
    SgfTerm rule;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OP_BRACKET_OPEN:
      jj_consume_token(OP_BRACKET_OPEN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
      case KW_LEFT:
      case KW_NACS:
      case KW_RIGHT:
      case KW_RULE:
      case KW_RULES:
      case KW_TRANS:
      case IDENT:
      case STRING:
        rule = rule();
                        result.add(rule);
        label_14:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_COMMA:
            ;
            break;
          default:
            jj_la1[42] = jj_gen;
            break label_14;
          }
          jj_consume_token(OP_COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case KW_INITIAL:
          case KW_LEFT:
          case KW_NACS:
          case KW_RIGHT:
          case KW_RULE:
          case KW_RULES:
          case KW_TRANS:
          case IDENT:
          case STRING:
            rule = rule();
                                       result.add(rule);
            break;
          default:
            jj_la1[43] = jj_gen;
            ;
          }
        }
        break;
      default:
        jj_la1[44] = jj_gen;
        ;
      }
      jj_consume_token(OP_BRACKET_CLOSE);
      {if (true) return result;}
      break;
    case KW_INITIAL:
    case KW_LEFT:
    case KW_NACS:
    case KW_RIGHT:
    case KW_RULE:
    case KW_RULES:
    case KW_TRANS:
    case IDENT:
    case STRING:
      rule = rule();
      result.add(rule); {if (true) return result;}
      break;
    default:
      jj_la1[45] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm gtsDef() throws ParseException {
    Token t;
    boolean initialSeen = false;
    boolean rulesSeen = false;
    SgfTerm initial = null;
    List<SgfTerm> rules = null;
    t = jj_consume_token(KW_GTS);
    jj_consume_token(OP_BRACE_OPEN);
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
      case KW_RULES:
        ;
        break;
      default:
        jj_la1[46] = jj_gen;
        break label_15;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
        jj_consume_token(KW_INITIAL);
        jj_consume_token(OP_IS);
          if (initialSeen) {if (true) throw new ParseException("Duplicate initial graph");}
          initialSeen = true;
        initial = graph();
        label_16:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_SEMICOLON:
            ;
            break;
          default:
            jj_la1[47] = jj_gen;
            break label_16;
          }
          jj_consume_token(OP_SEMICOLON);
        }
        break;
      case KW_RULES:
        jj_consume_token(KW_RULES);
        jj_consume_token(OP_IS);
          if (rulesSeen) {if (true) throw new ParseException("Duplicate rules section");}
          rulesSeen = true;
        rules = ruleList();
        label_17:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_SEMICOLON:
            ;
            break;
          default:
            jj_la1[48] = jj_gen;
            break label_17;
          }
          jj_consume_token(OP_SEMICOLON);
        }
        break;
      default:
        jj_la1[49] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return SgfTerm.createGtsDefTerm(t.beginLine, t.beginColumn, initial, rules);}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm systemDef() throws ParseException {
    Token t;
    boolean initialSeen = false;
    boolean rulesSeen = false;
    SgfTerm initial = null;
    SgfTerm trans;
    List<SgfTerm> transitions = new ArrayList<SgfTerm>();
    t = jj_consume_token(KW_SYSTEM);
    jj_consume_token(OP_BRACE_OPEN);
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
      case KW_TRANS:
        ;
        break;
      default:
        jj_la1[50] = jj_gen;
        break label_18;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_INITIAL:
        jj_consume_token(KW_INITIAL);
        jj_consume_token(OP_IS);
          if (initialSeen) {if (true) throw new ParseException("Duplicate initial graph");}
          initialSeen = true;
        initial = graph();
        label_19:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_SEMICOLON:
            ;
            break;
          default:
            jj_la1[51] = jj_gen;
            break label_19;
          }
          jj_consume_token(OP_SEMICOLON);
        }
        break;
      case KW_TRANS:
        jj_consume_token(KW_TRANS);
        jj_consume_token(OP_IS);
        jj_consume_token(OP_BRACKET_OPEN);
          if (rulesSeen) {if (true) throw new ParseException("Duplicate transitions section");}
          rulesSeen = true;
        trans = morphism();
                             transitions.add(trans);
        label_20:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_COMMA:
            ;
            break;
          default:
            jj_la1[52] = jj_gen;
            break label_20;
          }
          jj_consume_token(OP_COMMA);
          trans = morphism();
                                 transitions.add(trans);
        }
        jj_consume_token(OP_BRACKET_CLOSE);
        label_21:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OP_SEMICOLON:
            ;
            break;
          default:
            jj_la1[53] = jj_gen;
            break label_21;
          }
          jj_consume_token(OP_SEMICOLON);
        }
        break;
      default:
        jj_la1[54] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(OP_BRACE_CLOSE);
      {if (true) return SgfTerm.createEtsDefTerm(t.beginLine, t.beginColumn, initial, transitions);}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm copy() throws ParseException {
    Token t;
    RefTerm name;
    t = jj_consume_token(KW_COPY);
    jj_consume_token(OP_PAR_OPEN);
    name = ident();
    jj_consume_token(OP_PAR_CLOSE);
      {if (true) return SgfTerm.createCopyTerm(t.beginLine, t.beginColumn, name.getName());}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm definition() throws ParseException {
    RefTerm name = null;
    SgfTerm value;
    if (jj_2_2(2)) {
      name = ident();
      jj_consume_token(OP_IS);
    } else {
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KW_GRAPH:
      value = graphDef();
      break;
    case KW_IFGRAPH:
      value = ifGraphDef();
      break;
    case KW_RULE:
      value = ruleDef();
      break;
    case KW_MORPHISM:
      value = morphismDef();
      break;
    case KW_TRACE:
      value = traceDef();
      break;
    case KW_GTS:
      value = gtsDef();
      break;
    case KW_SYSTEM:
      value = systemDef();
      break;
    case KW_COPY:
      value = copy();
      break;
    default:
      jj_la1[55] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_22:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OP_SEMICOLON:
        ;
        break;
      default:
        jj_la1[56] = jj_gen;
        break label_22;
      }
      jj_consume_token(OP_SEMICOLON);
    }
        if (name == null)
            {if (true) return value;}
        else
            {if (true) return SgfTerm.createLetTerm(name.getLine(), name.getColumn(), name.getName(), value);}
    throw new Error("Missing return statement in function");
  }

  final private SgfTerm graphFile() throws ParseException {
    SgfTerm result;
    label_23:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OP_SEMICOLON:
        ;
        break;
      default:
        jj_la1[57] = jj_gen;
        break label_23;
      }
      jj_consume_token(OP_SEMICOLON);
    }
    result = graphDef();
    label_24:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OP_SEMICOLON:
        ;
        break;
      default:
        jj_la1[58] = jj_gen;
        break label_24;
      }
      jj_consume_token(OP_SEMICOLON);
    }
    jj_consume_token(0);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private List<SgfTerm> sgfFile() throws ParseException {
    SgfTerm current;
    List<SgfTerm> result = new ArrayList<SgfTerm>();
    label_25:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KW_COPY:
      case KW_GRAPH:
      case KW_GTS:
      case KW_IFGRAPH:
      case KW_INITIAL:
      case KW_LEFT:
      case KW_MORPHISM:
      case KW_NACS:
      case KW_RIGHT:
      case KW_RULE:
      case KW_RULES:
      case KW_SYSTEM:
      case KW_TRACE:
      case KW_TRANS:
      case IDENT:
      case STRING:
        ;
        break;
      default:
        jj_la1[59] = jj_gen;
        break label_25;
      }
      current = definition();
                               result.add(current);
    }
    jj_consume_token(0);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_3R_34() {
    if (jj_scan_token(KW_RULES)) return true;
    return false;
  }

  private boolean jj_3R_26() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_28()) {
    jj_scanpos = xsp;
    if (jj_3R_29()) {
    jj_scanpos = xsp;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) {
    jj_scanpos = xsp;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) {
    jj_scanpos = xsp;
    if (jj_3R_35()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_33() {
    if (jj_scan_token(KW_RIGHT)) return true;
    return false;
  }

  private boolean jj_3R_32() {
    if (jj_scan_token(KW_NACS)) return true;
    return false;
  }

  private boolean jj_3R_31() {
    if (jj_scan_token(KW_LEFT)) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_26()) return true;
    if (jj_scan_token(OP_IS)) return true;
    return false;
  }

  private boolean jj_3R_30() {
    if (jj_scan_token(KW_INITIAL)) return true;
    return false;
  }

  private boolean jj_3R_37() {
    if (jj_scan_token(OP_BINEDGE_LEFT)) return true;
    return false;
  }

  private boolean jj_3R_36() {
    if (jj_scan_token(OP_BINEDGE_START)) return true;
    return false;
  }

  private boolean jj_3R_27() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_36()) {
    jj_scanpos = xsp;
    if (jj_3R_37()) return true;
    }
    return false;
  }

  private boolean jj_3R_29() {
    if (jj_scan_token(STRING)) return true;
    return false;
  }

  private boolean jj_3R_28() {
    if (jj_scan_token(IDENT)) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_3R_26()) return true;
    Token xsp;
    if (jj_3R_27()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_27()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_35() {
    if (jj_scan_token(KW_TRANS)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public SgfParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[60];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x452c00,0x20000000,0x452c00,0x452c00,0x8452c00,0x452c00,0x0,0x0,0x80000000,0x80000000,0x0,0x20000000,0x452c00,0x452c00,0x456c00,0x0,0x456c00,0x456c00,0x452c80,0x40,0x100000,0x0,0x452c00,0x452c00,0x453c00,0x20000000,0x453c00,0x453c00,0x8453c00,0x453c80,0x20000000,0x453c80,0x652c00,0x0,0x0,0x0,0x0,0x13800,0x13800,0x8000,0x2013800,0x472c00,0x20000000,0x472c00,0x472c00,0x8472c00,0x40400,0x0,0x0,0x40400,0x400400,0x0,0x20000000,0x0,0x400400,0x2a13a0,0x0,0x0,0x0,0x6f3fa0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0xc0,0x0,0xc0,0xc0,0xc0,0xc0,0x4,0x4,0x2,0x2,0x4,0x0,0xc0,0xc0,0xc0,0x8,0xc0,0xc0,0xc0,0x0,0x0,0x8,0xc0,0xc0,0xc0,0x0,0xc0,0xc0,0xc0,0xc0,0x0,0xc0,0xc0,0x8,0x8,0x8,0x8,0x0,0x0,0x0,0x0,0xc0,0x0,0xc0,0xc0,0xc0,0x0,0x8,0x8,0x0,0x0,0x8,0x0,0x8,0x0,0x0,0x8,0x8,0x8,0xc0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[2];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public SgfParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public SgfParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new SgfParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 60; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 60; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public SgfParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new SgfParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 60; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 60; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public SgfParser(SgfParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 60; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(SgfParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 60; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[44];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 60; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 44; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 2; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
